"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""

import builtins
import collections.abc
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.message
import typing

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

@typing.final
class ReadSchemaRequest(google.protobuf.message.Message):
    """ReadSchemaRequest is the required data to read Object Definitions from
    a Schema.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    OBJECT_DEFINITIONS_NAMES_FIELD_NUMBER: builtins.int
    @property
    def object_definitions_names(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """The list of names of the Object Definitions that are being requested.

        These names must be fully qualified with their namespace (e.g.
        myblog/post).
        """

    def __init__(
        self,
        *,
        object_definitions_names: collections.abc.Iterable[builtins.str] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["object_definitions_names", b"object_definitions_names"]) -> None: ...

global___ReadSchemaRequest = ReadSchemaRequest

@typing.final
class ReadSchemaResponse(google.protobuf.message.Message):
    """ReadSchemaResponse is the resulting data after having read the Object
    Definitions from a Schema.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    OBJECT_DEFINITIONS_FIELD_NUMBER: builtins.int
    COMPUTED_DEFINITIONS_REVISION_FIELD_NUMBER: builtins.int
    computed_definitions_revision: builtins.str
    """The computed revision of the returned object definitions."""
    @property
    def object_definitions(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """The Object Definitions that were requested."""

    def __init__(
        self,
        *,
        object_definitions: collections.abc.Iterable[builtins.str] | None = ...,
        computed_definitions_revision: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["computed_definitions_revision", b"computed_definitions_revision", "object_definitions", b"object_definitions"]) -> None: ...

global___ReadSchemaResponse = ReadSchemaResponse

@typing.final
class WriteSchemaRequest(google.protobuf.message.Message):
    """WriteSchemaRequest is the required data used to "upsert" the Schema of a
    Permissions System.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    SCHEMA_FIELD_NUMBER: builtins.int
    OPTIONAL_DEFINITIONS_REVISION_PRECONDITION_FIELD_NUMBER: builtins.int
    schema: builtins.str
    """The Schema containing one or more Object Definitions that will be written
    to the Permissions System.
    256KiB
    """
    optional_definitions_revision_precondition: builtins.str
    """If specified, the existing revision of object definitions in the schema that must be present for
    the write to succeed. If the revision specified differs (i.e. the underlying schema has changed),
    the write call will fail with a FAILED_PRECONDITION error.
    """
    def __init__(
        self,
        *,
        schema: builtins.str = ...,
        optional_definitions_revision_precondition: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["optional_definitions_revision_precondition", b"optional_definitions_revision_precondition", "schema", b"schema"]) -> None: ...

global___WriteSchemaRequest = WriteSchemaRequest

@typing.final
class WriteSchemaResponse(google.protobuf.message.Message):
    """WriteSchemaResponse is the resulting data after having written a Schema to
    a Permissions System.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    OBJECT_DEFINITIONS_NAMES_FIELD_NUMBER: builtins.int
    COMPUTED_DEFINITIONS_REVISION_FIELD_NUMBER: builtins.int
    computed_definitions_revision: builtins.str
    """The computed revision of the written object definitions."""
    @property
    def object_definitions_names(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """The names of the Object Definitions that were written."""

    def __init__(
        self,
        *,
        object_definitions_names: collections.abc.Iterable[builtins.str] | None = ...,
        computed_definitions_revision: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["computed_definitions_revision", b"computed_definitions_revision", "object_definitions_names", b"object_definitions_names"]) -> None: ...

global___WriteSchemaResponse = WriteSchemaResponse
